;#########################################################################
;
;				WinGbt V2.8
;
;		      Del Nero Jean Franois 	1998 - 2000
;			jeanfrancoisdelnero@libero.it
;			     www.powerofasm.fr.st
;				
;				 I/O Interface 
;	
;#########################################################################
;  
;#########################################################################

.code

;#### Initialisation Interface
INITCARD proc
PUSH EAX
PUSH EDX
xor edx,edx
xor eax,eax
MOV DX,ds:[PPORT]
MOV AL,10000000B
pushad
invoke WritePort,edx,EAX
popad
xor eax,eax
INC DX
INC DX
MOV AL,00001111B
pushad
invoke WritePort,edx,EAX
popad
NOP
NOP
NOP
NOP
NOP
NOP
NOP
NOP
NOP
NOP
NOP
NOP
xor eax,eax
MOV AL,00000100B
invoke WritePort,edx,EAX
POP EDX
POP EAX
RET
INITCARD ENDP

;############### Detection Interface

CHECKPRESENCE PROC
 PUSH EAX
 PUSH EDX
 xor edx,edx
 mov dx,ds:[PPORT]
 mov ds:[tempdword3],edx
 cmp ds:[detectauto],0
je findectectionok
 XOR EDX,EDX
 AND EAX,0ffh
 MOV AH,2
 MOV AL,11111111b
 CALL WRITETOPORT
 MOV DX,DS:[PPORT]
 INC  DX 
 PUSH EDX
 invoke ReadPort,EDX 
 AND EAX,0ffh
 POP EDX
 AND AL,00001000b
Jz @@PASDNTERFACE
 MOV AH,2
 MOV AL,01111111b
 CALL WRITETOPORT
 MOV DX,DS:[PPORT]
 INC  DX 
 invoke ReadPort,EDX 
 AND EAX,0ffh
 AND AL,00001000b
JNZ @@PASDNTERFACE 
 MOV AH,2
 MOV AL,00000000b
 CALL WRITETOPORT
 POP EDX
 POP EAX
 call changeportmenu
 MOV AL,1
RET
findectectionok:
 call INITCARD 
 POP EDX
 POP EAX
 MOV AL,1
RET

@@PASDNTERFACE:
 MOV AH,2
 MOV AL,00000000b
 CALL WRITETOPORT
 POP EDX
 POP EAX
 call CHECKPRESENCE1
ret
CHECKPRESENCE ENDP


CHECKPRESENCE1 PROC
PUSH esi
PUSH edx

mov esi,offset TablePport
mov ds:[tempdword2],esi
mov dx,ds:[esi]
mov ds:[PPORT],dx

BoucleCHECKPRESENCE:
call INITCARD
XOR EDX,EDX
AND EAX,0ffh
;PUSH DX

MOV AH,2
MOV AL,11000000b
CALL WRITETOPORT
MOV DX,DS:[PPORT]
INC  DX 

PUSH EDX
invoke ReadPort,EDX 
AND EAX,0ffh
POP EDX

AND AL,00001000b
Jz PASDNTERFACE
MOV AH,2
MOV AL,01000000b
CALL WRITETOPORT
MOV DX,DS:[PPORT]
INC  DX 
invoke ReadPort,EDX 
AND EAX,0ffh
AND AL,00001000b
JNZ PASDNTERFACE
;POP DX

pop  edx
pop  esi
call changeportmenu
MOV AL,1
RET

PASDNTERFACE:
;POP DX
mov esi,ds:[tempdword2]
add esi,2
mov ds:[tempdword2],esi
mov dx,ds:[esi]
cmp dx,0ffffh
je fin478pasdi
MOV DS:[PPORT],DX
jmp BoucleCHECKPRESENCE
fin478pasdi:
mov edx,ds:[tempdword3]
MOV DS:[PPORT],DX
call changeportmenu 
pop  edx
pop  esi

XOR AL,AL
RET

CHECKPRESENCE1 ENDP

changeportmenu proc
pushad
MOV dx,DS:[PPORT]
cmp dx,378h
jne suitemenuport1

      invoke CheckMenuItem,hMenu,3378,MF_CHECKED or MF_BYCOMMAND
      invoke CheckMenuItem,hMenu,3278,MF_UNCHECKED or MF_BYCOMMAND
      invoke CheckMenuItem,hMenu,3399,MF_UNCHECKED or MF_BYCOMMAND
  jmp finmenuport
suitemenuport1:
MOV dx,DS:[PPORT]
cmp dx,278h
jne suitemenuport3

      invoke CheckMenuItem,hMenu,3378,MF_UNCHECKED or MF_BYCOMMAND
      invoke CheckMenuItem,hMenu,3278,MF_CHECKED or MF_BYCOMMAND
      invoke CheckMenuItem,hMenu,3399,MF_UNCHECKED or MF_BYCOMMAND
  jmp finmenuport

suitemenuport3:
MOV dx,DS:[PPORT]
cmp dx,3bch
jne finmenuport

      invoke CheckMenuItem,hMenu,3378,MF_UNCHECKED or MF_BYCOMMAND
      invoke CheckMenuItem,hMenu,3278,MF_UNCHECKED or MF_BYCOMMAND
      invoke CheckMenuItem,hMenu,3399,MF_CHECKED or MF_BYCOMMAND
finmenuport:
popad
ret
changeportmenu endp
;#######################


;####################### Ecriture Port 8255 (A ou B)
WRITETOPORT PROC  ;al=valeur ah=port
PUSHA

PUSHA
XOR EDX,EDX
XOR EAX,EAX
POPA
CMP AH,1
JE J101
CMP AH,2
JE J102
JMP J111
J101:
MOV CL,00000000b
JMP J110
J102:
MOV CL,00000100b
JMP J110
J110:
XOR EDX,EDX
MOV DX,DS:[PPORT]
PUSHAD
invoke WritePort,edx,EAX 
POPAD
AND EAX,0ffh
MOV AL,00001000b
OR AL,CL
ADD DX,2
PUSHAD
invoke WritePort,edx,EAX 
POPAD
NOP
NOP
NOP
MOV AL,00000000b   ;stop
OR AL,CL
PUSHAD
invoke WritePort,edx,EAX 
POPAD
J111:
POPA
RET
WRITETOPORT ENDP

;####################### Lecture Interface
READTOPORT PROC  
PUSH ECX
PUSH EDX
XOR EDX,EDX
XOR EAX,EAX
mov dx,DS:[PPORT]
add dx,2
MOV al,00100110b
PUSHAD 
invoke WritePort,edx,EAX 
POPAD

NOP
NOP
NOP
NOP
NOP
SUB DX,2
PUSH EDX
invoke ReadPort,EDX
AND EAX,0ffh
POP EDX
NOP
NOP
NOP
NOP
NOP
NOP
NOP
NOP
push ax
add dx,2
MOV al,00000100b
PUSHAD
invoke WritePort,edx,EAX 
POPAD
pop ax
J1110:
POP EDX
POP ECX
RET
READTOPORT ENDP

;####################### Lecture Interface SRam
READTOPORTSRAM PROC  
PUSH ECX
PUSH EDX
XOR EDX,EDX
XOR EAX,EAX
mov dx,DS:[PPORT]
add dx,2
MOV al,00100010b
PUSHAD 
invoke WritePort,edx,EAX 
POPAD

NOP
NOP
NOP
NOP
NOP
SUB DX,2
PUSH EDX
invoke ReadPort,EDX
AND EAX,0ffh
POP EDX
NOP
NOP
NOP
NOP
NOP
NOP
NOP
NOP
push ax
add dx,2
MOV al,00000100b
PUSHAD
invoke WritePort,edx,EAX 
POPAD
pop ax
J1110:
POP EDX
POP ECX
RET
READTOPORTSRAM ENDP

;####################### Lecture Cartouche a l'adresse BX
LECTURECAR PROC   ;BX=ADDRESSE DE LECTURE >AL=DATA
mov al,bl
push ax
mov ah,1
call WRITETOPORT
mov al,bh
inc ah
call WRITETOPORT
pop ax
call READTOPORT
RET
LECTURECAR ENDP

LECTURECARSRAM PROC   ;BX=ADDRESSE DE LECTURE >AL=DATA
mov al,bl
push ax
mov ah,1
call WRITETOPORT
mov al,bh
inc ah
call WRITETOPORT
pop ax
call READTOPORTSRAM
RET
LECTURECARSRAM ENDP

;####################### Ecriture Cartouche a l'adresse BX
ECRISCAR PROC   ;al=valeur ah=type  BX=ADDRESSE DE LECTURE >AL=DATA
pushad          ;            =1 NINTENDO 
NOP
NOP
NOP
NOP
NOP

push ax         ;            =0 SRAM
XOR EDX,EDX
mov ax,bx       ;          cl=mode =0 MCB
MOV DL,AH       ;                  =1 CARTOUCHE
mov ah,1        ;
call WRITETOPORT
mov al,DL
mov ah,2
call WRITETOPORT
pop ax
MOV DX,DS:[PPORT]
PUSH EDX
and edx,0ffffh
invoke WritePort,edx,EAX
AND EAX,0ffh
POP EDX
NOP
NOP
NOP
NOP
NOP
NOP
ADD DX,2
MOV AL,00000001b
CMP CL,1
JNE JP1111
CMP DS:[MCBNORM],0
JNE JP1111
mov al,00000010b
JP1111:
PUSH EDX
and edx,0ffffh
invoke WritePort,edx,EAX 
AND EAX,0ffh
POP EDX
NOP
NOP
NOP
NOP
NOP
MOV al,00000000b
PUSH EDX
and edx,0ffffh
invoke WritePort,edx,EAX 
AND EAX,0ffh
POP EDX
NOP
NOP
NOP
NOP
NOP
NOP
NOP
NOP
NOP
NOP
popad
RET
ECRISCAR ENDP

;####################### Ecriture Cartouche a l'adresse BX
ECRISCAR2 PROC   ;al=valeur ah=type  BX=ADDRESSE DE LECTURE >AL=DATA
pushad          ;            =1 NINTENDO
push ax         ;            =0 SRAM
XOR EDX,EDX
mov ax,bx       ;          cl=mode =0 MCB
MOV DL,AH       ;                  =1 CARTOUCHE
mov ah,1        ;
call WRITETOPORT
mov al,DL
mov ah,2
call WRITETOPORT
pop ax
MOV DX,DS:[PPORT]
PUSH EDX
and edx,0ffffh
invoke WritePort,edx,EAX 
AND EAX,0ffh
POP EDX
NOP
NOP
NOP
NOP
NOP
NOP
ADD DX,2
MOV AL,00000010b
PUSH EDX
and edx,0ffffh
invoke WritePort,edx,EAX 
AND EAX,0ffh
POP EDX
NOP
NOP
NOP
NOP
NOP
MOV al,00000000b
PUSH EDX
and edx,0ffffh
invoke WritePort,edx,EAX 
AND EAX,0ffh
POP EDX
popad
RET
ECRISCAR2 ENDP

;####################### Copie Bank0 -> Buffer1
COPYBANK0 PROC
PUSHAD
MOV ESI,OFFSET BufferCartouche1
xor bx,bx
mov cx,16*1024
Bouclecopyb0100:
call LECTURECAR
mov ds:[esi],al
inc bx
inc esi
dec cx
jnz Bouclecopyb0100
POPAD
RET
COPYBANK0 ENDP

;####################### Copie BankN -> Buffer2
COPYBANK1 PROC
PUSHAD
MOV ESI,OFFSET BufferCartouche2
mov bx,4000h
mov cx,16*1024
Bouclecopyb1100:
call LECTURECAR
mov ds:[esi],al
inc bx
inc esi
dec cx
jnz Bouclecopyb1100
POPAD
RET
COPYBANK1 ENDP

;####################### Copie Bank Sram -> Buffer 2
COPYSRAMBANK PROC
PUSHAD
MOV ESI,OFFSET BufferCartouche2
mov bx,0a000h
mov cx,ds:[sizebanksram];8*1024
Bouclecopyb1100:
call LECTURECARSRAM
mov ds:[esi],al
inc bx
inc esi
dec cx
jnz Bouclecopyb1100
POPAD
RET
COPYSRAMBANK ENDP

;####################### Copie Buffer -> Bank 0
WRITEBANK0 PROC
PUSHAD
MOV ESI,OFFSET BufferCartouche1
xor bx,bx
mov cx,16*1024
Bouclecopyb0100:
mov al,ds:[esi]
push cx
xor cx,cx
CALL ECRISCAR  ;al=valeur ah=type  BX=ADDRESSE DE LECTURE >AL=DATA
pop cx
inc bx
inc esi
dec cx
jnz Bouclecopyb0100
POPAD
RET
WRITEBANK0 ENDP

;####################### Copie Buffer 2 -> BankN
WRITEBANK1 PROC
PUSHAD
MOV ESI,OFFSET BufferCartouche2
mov bx,4000h
mov cx,16*1024
Bouclecopyb0100:
mov al,ds:[esi]
push cx
xor cx,cx
CALL ECRISCAR  ;al=valeur ah=type  BX=ADDRESSE DE LECTURE >AL=DATA
pop cx
inc bx
inc esi
dec cx
jnz Bouclecopyb0100
POPAD
RET
WRITEBANK1 ENDP

;####################### Copie Buffer 2 -> SRam
WRITESRAMBANK PROC
PUSHAD
MOV ESI,OFFSET BufferCartouche2
mov bx,0a000h
mov cx,ds:[sizebanksram];8*1024
Bouclecopyb0100:
mov al,ds:[esi]
push cx
xor cx,cx
CALL ECRISCAR  ;al=valeur ah=type  BX=ADDRESSE DE LECTURE >AL=DATA
pop cx
inc bx
inc esi
dec cx
jnz Bouclecopyb0100
POPAD
RET
WRITESRAMBANK ENDP

;######## Deverrouillage SRAM
UNLOCKSRAM PROC
pushad
mov al,0ah
mov bx,0h
mov cx,0
CALL ECRISCAR  ;al=valeur ah=type  BX=ADDRESSE DE LECTURE >AL=DATA
popad
ret
UNLOCKSRAM ENDP

;######## verrouillage SRAM
LOCKSRAM PROC
pushad
    Mov BX,0a000h
    Boucleecris2bank1sav:
    CALL LECTURECARSRAM
    mov dl,al
    and al,00001111b
    jz hjhkljhfdskmhfdg
    inc bx
    cmp bx,0c000h
    jne Boucleecris2bank1sav
    mov bx,0bfffh
    xor dl,dl
  hjhkljhfdskmhfdg:
sub bx,0a000h
mov al,dl
mov cx,0
;CALL LECTURECARSRAM

CALL ECRISCAR  ;al=valeur ah=type  BX=ADDRESSE DE LECTURE >AL=DATA

popad
ret
LOCKSRAM ENDP


;######## Copie partielle Bank0 -> Buffer 1 
FASTCOPYBANK0 PROC
PUSHAD
MOV ESI,OFFSET BufferCartouche1
xor bx,bx
mov cx,200h
Bouclecopyb0100:
call LECTURECAR
mov ds:[esi],al
inc bx
inc esi
dec cx
jnz Bouclecopyb0100
POPAD
RET
FASTCOPYBANK0 ENDP

;######## Copie partielle Bank0 (logo cartouche) -> Buffer 1 
VFASTCOPYBANK0 PROC
PUSHAD
MOV ESI,OFFSET BufferCartouche1+100h
mov bx,100h
mov cx,42h
Bouclecopyb0100:
call LECTURECAR
mov ds:[esi],al
inc bx
inc esi
dec cx
jnz Bouclecopyb0100
POPAD
RET
VFASTCOPYBANK0 ENDP

;#### Scan logo
CHECKLOGO PROC
PUSHAD
MOV ESI,OFFSET BufferCartouche1 + 104h
MOV EDI,OFFSET LOGONINTENDO
mov cx,133h - 104h
Bouclechecklogo:
mov al,ds:[esi]
mov ah,ds:[edi]
cmp ah,al
jne finpasbonlogo
inc esi
inc edi
dec cx
jnz Bouclechecklogo
POPAD
mov al,1
ret
finpasbonlogo:
POPAD
mov al,0
ret
CHECKLOGO ENDP

;#### CheckSum Bank0
CHECKSUMBANK0 PROC
PUSHAD
xor cx,cx
mov ds:[tempword],cx
mov esi,offset BufferCartouche1
mov dx,16384     
boucleCHECKSUMBANK0:
cmp esi,offset BufferCartouche1 + 14eh
je jp3001
cmp esi,offset BufferCartouche1 + 14fh
je jp3001
mov al,ds:[esi]
mov cx,ds:[tempword]
mov ah,0
add cx,ax
mov ds:[tempword],cx
jp3001:
inc esi
dec dx
jnz boucleCHECKSUMBANK0
POPAD
RET
CHECKSUMBANK0 ENDP

;#### CheckSum BankN

CHECKSUMBANK1 PROC
PUSHAD
mov esi,offset BufferCartouche2
mov dx,16384  
boucleCHECKSUMBANK1:
mov al,ds:[esi]
mov cx,ds:[tempword]
mov ah,0
add cx,ax
mov ds:[tempword],cx
inc esi
dec dx
jnz boucleCHECKSUMBANK1
POPAD
RET
CHECKSUMBANK1 ENDP


;###### Nombre de bloque (sram) ?

GetNombreDeBlockSram Proc
Push esi

        mov esi,offset blocktablesram
        xor eax,eax
        mov al,ds:[BufferCartouche1 + 149h]
        add esi,eax
        mov al,ds:[esi]
pop esi
ret
GetNombreDeBlockSram Endp


;###### Nombre de bloque ?

GetNombreDeBlock proc
Push esi

        mov esi,offset blocktable
        xor eax,eax
        mov al,ds:[BufferCartouche1 + 148h]
        add esi,eax
        mov al,ds:[esi]
pop esi
ret
GetNombreDeBlock Endp

;###### Changement Bloque
ChangeBank Proc ;al=bank
pushad
     XOR CX,CX
     MOV BX,2100h
     CALL ECRISCAR
popad
ret
ChangeBank EndP


;###### Changement Bloque (sram)

ChangeBankSram Proc ;al=bank
pushad
     XOR CX,CX
     MOV BX,4100h
     CALL ECRISCAR
popad
ret
ChangeBankSram EndP

;#### 'Arret' Interface

SHUTDOWNINTERF PROC
pushad
mov al,0
mov ah,1
call WRITETOPORT   ;al=valeur ah=port
mov al,0
mov ah,2
call WRITETOPORT   ;al=valeur ah=port

MOV DX,DS:[PPORT]
xor eax,eax
and edx,0ffffh
invoke WritePort,edx,EAX

MOV DX,DS:[PPORT]
and edx,0ffffh
xor eax,eax
mov al,00001011b
add edx,2
invoke WritePort,edx,EAX
popad
ret
SHUTDOWNINTERF ENDP

;#######################################################################
