; #########################################################################

;     include files
;     ~~~~~~~~~~~~~
      include \masm32\INCLUDE\windows.inc
      include \masm32\INCLUDE\masm32.inc
      include \masm32\INCLUDE\gdi32.inc
      include \masm32\INCLUDE\user32.inc
      include \masm32\INCLUDE\kernel32.inc
      include \masm32\INCLUDE\Comctl32.inc
      include \masm32\INCLUDE\comdlg32.inc
      include \masm32\INCLUDE\shell32.inc
	include tvicport.inc
;     libraries
;     ~~~~~~~~~
      includelib \masm32\LIB\masm32.lib

      includelib \masm32\LIB\gdi32.lib
      includelib \masm32\LIB\user32.lib
      includelib \masm32\LIB\kernel32.lib
      includelib \masm32\LIB\Comctl32.lib
      includelib \masm32\LIB\comdlg32.lib
      includelib \masm32\LIB\shell32.lib
      includelib tvicport.lib
; #########################################################################

        ;=================
        ; Local prototypes
        ;=================
        WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
        WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
        TopXY PROTO   :DWORD,:DWORD
        FillBuffer   PROTO :DWORD,:DWORD,:BYTE
        Paint_Proc   PROTO :DWORD,:DWORD

        wsprintfA PROTO C :DWORD,:VARARG
        wsprintf equ <wsprintfA>

      ;=============
      ; Local macros
      ;=============

      szText MACRO Name, Text:VARARG
        LOCAL lbl
          jmp lbl
            Name db Text,0
          lbl:
        ENDM

      m2m MACRO M1, M2
        push M2
        pop  M1
      ENDM

      return MACRO arg
        mov eax, arg
        ret
      ENDM

        SCREEN_WIDTH=320
        SCREEN_HEIGHT=200



    .data
dibinf LABEL BITMAPINFO
BITMAPINFOHEADER < \ ;
 sizeof BITMAPINFOHEADER, \ ;biSize
 SCREEN_WIDTH,            \ ;biWidth
 -SCREEN_HEIGHT,          \ ;biHeight
 1,                       \ ;biPlanes
 8,                       \ ;biBitCount
 BI_RGB,                  \ ;biCompression
 0,                       \ ;biSizeImage
 0,                       \ ;biXPelsPerMeter
 0,                       \ ;biYPelsPerMeter
 0,                       \ ;biClrUsed
 0>                         ;biClrImportant
Win_Palette RGBQUAD 256 dup (<>) ; RGB + reserved = 4 bytes



LOGONINTENDO DB 0CEh,0EDh,66h,66h,0CCh,0Dh,00h,0Bh,03h,73h,00h,83h,00h,0Ch,00h,0Dh
             DB 00,08,11h,1Fh,88h,89h,00,0Eh,0DCh,0CCh,6Eh,0E6h,0DDh,0DDh,0D9h,099h
             DB 0BBh,0BBh,67h,63h,6Eh,0Eh,0ECh,0CCh,0DDh,0DCh,99h,9Fh,0BBh,0B9h,33h,3Eh

	buffer001 db 50 dup(0)

        MAIN_THREAD_STACKSIZE_KB=16
        MAXSIZE equ 260
        EscapePressed Db 0
        szDisplayName    db "GameBoy Trans-fer V2.8 "
        DisplayName      db 50 DUP(0)
        Transfer       db 0h
        MCBNORM       DB 0h
        MCBNORM2       DB 0h
        
        CommandLine   dd 0
        hWnd          dd 0
        hMenu         dd 0
        hInstance     dd 0
        hFile	      dd 0
        hIcon         dd 0
        tempoctet     db 0
        PPORT         DW 378h
        TablePport    DW 378h,278h,3BCh,0FFFFh

        ofn   OPENFILENAME <>
        FilterStringAdr dd offset FilterString
        FilterString db "Rom GameBoy (*.gb)",0,"*.gb",0
                     db "Rom GameBoy color (*.gbc)",0,"*.gbc",0   
                     db "Tout les fichiers",0,"*.*",0,0

        FilterString2 db "Sauvegarde (*.sav)",0,"*.sav",0
                      db "Tout les fichiers",0,"*.*",0,0

        buffer db MAXSIZE dup(0)
        pointeurdessin dd offset dessin +1078
    	  sizewri dd 0
        blocktable  Db 2,4,8,16,32,64,128,255
        blocktablesram  Db 0,0ffh,1,4,16,64,128,255

        tempword    dw 0
        tempdword   dd 0
        UpdateInfo  dd 0
        Rafraichissement db 0ffh
        detectauto db 0ffh
        messageerioport db "Attention !! : Le driver Tvicport n`a pas t initialis !",10,13
                        db "Verifiez la prsence du fichier vicprt00.vxd dans le repertoire courant",10,13
                        db "ou dans le repertoire SYSTEM de windows... ",10,13
                        db "Pour Windows NT verifiez la prsence du fichier vicprt00.sys dans C:\WINNT\SYSTEM32\DRIVERS....",10,13
                        db "Gbt32 ne peux acceder a votre interface ... Voulez-vous continuer ? ",10,13,0

       AboutMsg db "Game Boy Trans-fer V2.8",13,10
                db "--100% Asm--",10,13 
                db "by Del Nero Jean Franois",10,13,13,10
                db "HxC 2001 Production  ",13,10
                db " HxC 2000 ",13,10
                db "http://www.powerofasm.fr.st",13,10
                db "Email: jeanfrancoisdelnero@libero.it",10,13,13,10
                db "Graph :Nebulah Frost",13,10
                db "http://www.obsolete-tears.fr.st",10,13,0

        checksum  dw 0

        sizebanksram dw 8*1024

        compteurbloque db 0
        compteurbloque2 db 1
        ALaLigne  DB 13,10,0
        InfoCart1 DB "Nom de la Cartouche : ",0
        InfoCart2 DB "Type de cartouche   : ",0
        InfoCart3 DB "Rom Byte            : ",0
        InfoCart4 DB "Ram Byte            : ",0
        InfoCart5 DB "Japan Byte          : ",0
        InfoCart6 DB "Licence Code        : ",0
        InfoCart7 DB "Version             : ",0
        InfoCart8 DB "Color Gb Byte       : ",0
        InfoCart9 DB "Super Gb Byte       : ",0
        InfoCart10 DB "CheckSum            : ",0
        InfoCart11 DB "New Licence Code    : ",0

        ALIGN 4

	.data?
        BufferCartouche1 db 16*1024 + 1024 dup (?)     
        BufferCartouche2 db 16*1024 + 1024 dup (?)     
        FrameBuffer db SCREEN_WIDTH*SCREEN_HEIGHT+512 dup (?)
        nomfich db 128 dup(?) 
        nbblock5 db ?
        tempdword2   dd ?
        tempdword3   dd ?
        MainThreadHandle DD ?
        myDC HDC ?
        OutputString db 1512 DUP(?)
        TempString   db 16 DUP(?)

; ########################### Inserted modules ############################


; #########################################################################
